var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
const defaultEmptyValue = undefined;
function isValueEmpty(value) {
    return value === null || value === undefined;
}
let IntegerInput = class IntegerInput extends LitElement {
    constructor() {
        super(...arguments);
        this.value = defaultEmptyValue;
        this.rawValue = '';
        this.emptyValue = defaultEmptyValue;
        this.previousInputValue = '';
    }
    willUpdate(changedProperties) {
        if (changedProperties.has('emptyValue') && isValueEmpty(this.value)) {
            this.value = this.emptyValue;
        }
    }
    handleInput(e) {
        const inputElement = e.target;
        if (inputElement.value === '' || inputElement.value.match(/^-?\d*$/)) {
            if (inputElement.value === '') {
                this.value = this.emptyValue;
            }
            else if (inputElement.value.match(/^-?\d+$/)) {
                this.value = Number(inputElement.value);
            }
            this.previousInputValue = inputElement.value;
        }
        else {
            inputElement.value = this.previousInputValue;
        }
        this.rawValue = inputElement.value;
    }
    handleBlur(e) {
        const inputElement = e.target;
        if (inputElement.value === '-') {
            inputElement.value = '';
        }
    }
    render() {
        if (isValueEmpty(this.value) && this.value !== this.emptyValue) {
            console.warn(`value is empty but does not match emptyValue. value: "${this.value}", emptyValue: "${this.emptyValue}"`);
        }
        return html `<input
      .value=${this.rawValue}
      @input=${this.handleInput}
      @blur=${this.handleBlur}
    />`;
    }
};
__decorate([
    property({ type: Number })
], IntegerInput.prototype, "value", void 0);
__decorate([
    property({ attribute: 'raw-value' })
], IntegerInput.prototype, "rawValue", void 0);
__decorate([
    property({ attribute: 'empty-value' })
], IntegerInput.prototype, "emptyValue", void 0);
IntegerInput = __decorate([
    customElement('integer-input-lit')
], IntegerInput);
export { IntegerInput };
//# sourceMappingURL=integer-input.js.map